#
# Copyright (c) 2003-2004 Linuxant inc.
#
# NOTE: The use and distribution of this software is governed by the terms in
# the file LICENSE, which is included in the package. You must read this and
# agree to these terms before using or distributing this software.
#
-include $(TOP)/modules/imported/makeflags.mak

# The version string specified here is propagated everywhere
DLDRVERSION=$(IMPORTED_DLDRVERSION)
DLDRPKGREL=1

DLDRNAME=$(IMPORTED_DLDRNAME)
DLDRABBR=$(IMPORTED_DLDRABBR)
DLDRDESC=$(IMPORTED_DLDRDESC)

DLDROEM=$(IMPORTED_DLDROEM)

# DLDRCNFADDR and DLDRCNFPORT are the default address and
# port numbers used by the web configurator.
# You can leave them blank to disable it. 
DLDRCNFADDR=$(IMPORTED_DLDRCNFADDR)
DLDRCNFPORT=$(IMPORTED_DLDRCNFPORT)

# DLDRNETIF is the default network interface name format
# On Suse 9, it is overridden to "wlan%d" in dldrconfig
# %d is substituted with the instance number; so eth%d becomes eth0, eth1, etc..
DLDRNETIF=eth%d

ROOT=
PREFIX=$(ROOT)/usr

ETCDIR=$(ROOT)/etc
VARDIR=$(ROOT)/var
SBINDIR=$(PREFIX)/sbin
BINDIR=$(PREFIX)/bin
LIBDIR=$(PREFIX)/lib

DLDRETCDIR=$(ETCDIR)/$(DLDRNAME)
DLDRCNFDIR=$(DLDRETCDIR)/config
DLDRNVMDIR=$(DLDRETCDIR)/static

DLDRSBINDIR=$(SBINDIR)
DLDRBINDIR=$(BINDIR)

DLDRLIBDIR=$(LIBDIR)/$(DLDRNAME)
DLDRMODDIR=$(DLDRLIBDIR)/modules
DLDRVARDIR=$(VARDIR)/lib/$(DLDRNAME)

# On some Debian variants, there is no cc symlink to gcc
ifeq ($(CC),cc)
CC := gcc
endif

INSTALL= install
MKDIR=   mkdir -m 755

ALL_IN = $(shell find . -name "*.in")
ALL_IN_GEN = $(patsubst %.in, %, $(ALL_IN))

%: %.in
	sed \
		-e 's!@PREFIX@!$(PREFIX)!g' \
		-e 's!@DLDRNAME@!$(DLDRNAME)!g' \
		-e 's!@DLDRABBR@!$(DLDRABBR)!g' \
		-e 's!@DLDRDESC@!$(DLDRDESC)!g' \
		-e 's!@DLDROEM@!$(DLDROEM)!g' \
		-e 's!@DLDRNETIF@!$(DLDRNETIF)!g' \
		-e 's!@DLDRETCDIR@!$(DLDRETCDIR)!g' \
		-e 's!@DLDRLIBDIR@!$(DLDRLIBDIR)!g' \
		-e 's!@DLDRVARDIR@!$(DLDRVARDIR)!g' \
		-e 's!@DLDRNVMDIR@!$(DLDRNVMDIR)!g' \
		-e 's!@DLDRCNFDIR@!$(DLDRCNFDIR)!g' \
		-e 's!@DLDRSBINDIR@!$(DLDRSBINDIR)!g' \
		-e 's!@DLDRVERSION@!$(DLDRVERSION)!g' \
		-e 's!@DLDRCNFADDR@!$(DLDRCNFADDR)!g' \
		-e 's!@DLDRCNFPORT@!$(DLDRCNFPORT)!g' \
		-e 's!@DLDRRMMODS@!$(DLDRRMMODS)!g' \
		< $< > $@
	chmod --reference=$< $@
