/*
 * Copyright (c) 2003-2004 Linuxant inc.
 *
 * NOTE: The use and distribution of this software is governed by the terms in
 * the file LICENSE, which is included in the package. You must read this and
 * agree to these terms before using or distributing this software.
 *
 */

#ifndef __OSSERVICES_H__
#define __OSSERVICES_H__

#include "typedefs.h"

__shimcall__ int OsInit(BOOLEAN *regParm, BOOLEAN sw);
__shimcall__ void OsExit(void);

__shimcall__ void *OsAllocate(unsigned size);
__shimcall__ void OsFree(PVOID pMem);
__shimcall__ void *OsDmaAllocate(HANDLE DevNode, unsigned size, unsigned long *physAddr);
__shimcall__ void OsDmaFree(HANDLE DevNode, unsigned size, void *vAddr, unsigned long physAddr);

typedef struct tagHCRIT {
	int dummy;
} *HCRIT;

__shimcall__ HCRIT	OsCriticalSectionCreate(void);
__shimcall__ VOID	OsCriticalSectionDestroy(IN HCRIT hMutex);
__shimcall__ VOID	OsCriticalSectionAcquire(IN HCRIT hMutex);
__shimcall__ VOID	OsCriticalSectionRelease(IN HCRIT hMutex);

#ifndef OS_NOREDEFS
#if !(defined(__GNUC__) && defined(__i386__) && !defined(OS_NOSTRINGREDEFS) && !defined(_I386_STRING_H_))
#undef memset
#define memset          OsMemSet
#undef memcpy
#define memcpy          OsMemCpy
#undef memcmp
#define memcmp          OsMemCmp
#undef memmove
#define memmove         OsMemMove
#undef memchr
#define memchr          OsMemChr

#undef strcpy
#define strcpy          OsStrCpy
#undef strncpy
#define strncpy         OsStrnCpy
#undef strcat
#define strcat          OsStrCat
#undef strncat
#define strncat         OsStrnCat
#undef strcmp
#define strcmp          OsStrCmp
#undef strncmp
#define strncmp         OsStrnCmp
#undef strcasecmp
#define strcasecmp      OsStrCaseCmp
#undef strncasecmp
#define strncasecmp     OsStrnCaseCmp
#undef strlen
#define strlen          OsStrLen
#endif /* !(defined(__GNUC__) && defined(__i386__) && !defined(OS_NOSTRINGREDEFS) && !defined(_I386_STRING_H_)) */
#undef toupper
#define toupper         OsToupper
#undef tolower
#define tolower         OsTolower
#undef isdigit
#define isdigit         OsIsDigit
#undef sprintf
#define sprintf         OsSprintf
#undef atoi
#define atoi			OsAtoi
#endif /* OS_NOREDEFS */

#if defined(__GNUC__) && defined(__i386__) && !defined(OS_NOSTRINGREDEFS) && !defined(_I386_STRING_H_)
#include <string.h>
#undef OsMemSet
#define OsMemSet memset
#undef OsMemCpy
#define OsMemCpy memcpy
#undef OsMemMove
#define OsMemMove memmove
#undef OsMemChr
#define OsMemChr memchr
#undef OsMemCmp
#define OsMemCmp memcmp
#undef OsStrCpy
#define OsStrCpy strcpy
#undef OsStrnCpy
#define OsStrnCpy strncpy
#undef OsStrCat
#define OsStrCat strcat
#undef OsStrnCat
#define OsStrnCat strncat
#undef OsStrCmp
#define OsStrCmp strcmp
#undef OsStrnCmp
#define OsStrnCmp strncmp
#undef OsStrCaseCmp
#define OsStrCaseCmp strcasecmp
#undef OsStrnCaseCmp
#define OsStrnCaseCmp strncasecmp
#undef OsStrLen
#define OsStrLen strlen
#else
__shimcall__ PVOID   OsMemSet    (PVOID pBuf, UINT8 c, UINT32 Count);
__shimcall__ PVOID	OsMemCpy    (PVOID pDest, const void *pSrc, UINT32 Count);
__shimcall__ PVOID	OsMemMove   (PVOID pDest, const void *pSrc, UINT32 Count);
__shimcall__ PVOID OsMemChr		(void *s, int c, size_t n);
__shimcall__ int		OsMemCmp    (const void *pBuff1, const void *pBuff2, UINT32 Count);

__shimcall__ PVOID	OsStrCpy    (LPSTR szDest, LPCSTR szSrc);
__shimcall__ PVOID	OsStrnCpy   (LPSTR szDest, LPCSTR szSrc, int MaxSize);
__shimcall__ LPSTR	OsStrCat    (LPSTR szDest, LPCSTR szSrc);
__shimcall__ LPSTR	OsStrnCat   (LPSTR szDest, LPCSTR szSrc, int MaxSize);
__shimcall__ int     OsStrCmp    (LPCSTR szStr1, LPCSTR szStr2);
__shimcall__ int     OsStrnCmp   (LPCSTR szStr1, LPCSTR szStr2, UINT32 Count);
__shimcall__ int     OsStrCaseCmp(LPCSTR szStr1, LPCSTR szStr2);
__shimcall__ int     OsStrnCaseCmp(LPCSTR szStr1, LPCSTR szStr2, UINT32 Count);
__shimcall__ int	    OsStrLen    (LPCSTR szStr);
#endif
__shimcall__ int	    OsAtoi      (LPCSTR szStr);
__shimcall__ unsigned long OsStrtoul   (const char *nptr, char **endptr, int base);
__shimcall__ int	    OsToupper   (int c);
__shimcall__ int	    OsTolower   (int c);
__shimcall__ int	    OsIsDigit   (int c);
#include <stdarg.h>
__shimcall__ int     OsSprintf   (LPSTR buffer, LPCSTR format, ...);
__shimcall__ int     OsSNprintf   (LPSTR buffer, int n, LPCSTR format, ...);
__shimcall__ int     OsVSprintf  (LPSTR buffer, LPCSTR format, va_list valist);
__shimcall__ int     OsVSNprintf  (LPSTR buffer, int n, LPCSTR format, va_list valist);

__shimcall__ UINT32	OsGetSystemTime(void);
__shimcall__ void	OsGetSystemTimeSecUSec(long *s, long *us);
__shimcall__ UINT32	OsGetSystemUpTime(void);
__shimcall__ ULONG OsGetTickCount(void);

__shimcall__ void	OsSleep (UINT32 sleepTime);
__shimcall__ void	OsMicroSleep(UINT32 us);

__shimcall__ void	OsDumpData(const void *bp, unsigned int length);

__shimcall__ void    OsErrorVPrintf       (LPCSTR szFormat, PVOID args);
__shimcall__ void    OsErrorPrintf       (LPCSTR szFormat, ...)
#ifdef __GNUC__
	__attribute__ ((format (printf, 1, 2)))
#endif
	;
#define OsErrorDump OsDumpData
#ifdef DLDR_DEBUG
__shimcall__ void    OsDebugVPrintf       (LPCSTR szFormat, PVOID args);
__shimcall__ void    OsDebugPrintf       (LPCSTR szFormat, ...)
#ifdef __GNUC__
	__attribute__ ((format (printf, 1, 2)))
#endif
	;
#define OsDebugDump OsDumpData
#else
#define OsDebugVPrintf(...) do {} while(0)
#define OsDebugPrintf(...) do {} while(0)
#define OsDebugDump(...) do {} while(0)
#endif

#ifdef DLDR_TEST
#define OsTestPrintf OsErrorPrintf
#define OsTestVPrintf OsErrorVPrintf
#define OsTestDump OsErrorDump
#else
#define OsTestPrintf OsDebugPrintf
#define OsTestVPrintf OsDebugVPrintf
#define OsTestDump OsDebugDump
#endif

#ifdef DLDR_TRACE
#define OsTracePrintf OsErrorPrintf
#define OsTraceVPrintf OsErrorVPrintf
#define OsTraceDump OsErrorDump
#else
#define OsTracePrintf OsDebugPrintf
#define OsTraceVPrintf OsDebugVPrintf
#define OsTraceDump OsDebugDump
#endif

#if defined(DLDR_TEST) || defined(DLDR_TRACE)
#define OsTestTracePrintf OsErrorPrintf
#define OsTestTraceVPrintf OsErrorVPrintf
#define OsTestTraceDump OsErrorDump
#else
#define OsTestTracePrintf OsDebugPrintf
#define OsTestTraceVPrintf OsDebugVPrintf
#define OsTestTraceDump OsDebugDump
#endif

__shimcall__ void    OsErrorPrintf       ( LPCSTR szFormat, ...);

typedef struct {
	unsigned long dummy[20]; // must be at least sizeof(struct timer_list)
} OSTIMER, *HOSTIMER;

__shimcall__ int OsGetTimerSize(void);
__shimcall__ void OsInitTimer(HOSTIMER pTimer, __kernelcall__ void (*func)(void *), void * data);
__shimcall__ int OsSetTimer(HOSTIMER pTimer, UINT32 msec);
__shimcall__ int OsCancelTimer(HOSTIMER pTimer, BOOLEAN sync);
__shimcall__ BOOLEAN OsPendingTimer(HOSTIMER pTimer);

typedef struct tagHOSDPC
{
	int dummy;
} *HOSDPC;

__shimcall__ HOSDPC OsDpcCreate(__kernelcall__ void (*func)(void *), void * data);
__shimcall__ void OsDpcDestroy(HOSDPC hDpc);
__shimcall__ void OsDpcSchedule(HOSDPC hDpc);
__shimcall__ void OsDpcEnable(HOSDPC hDpc);
__shimcall__ void OsDpcDisable(HOSDPC hDpc);
__shimcall__ void OsDpcDisableNoSync(HOSDPC hDpc);

typedef enum {
	OSIRQL_PASSIVE,
	OSIRQL_APC,
	OSIRQL_DISPATCH,
	OSIRQL_DEVICE,
	OSIRQL_HIGH
} OSIRQL;

__shimcall__ const char *OsIrqlName(OSIRQL Irql);

__shimcall__ OSIRQL OsGetIrql(void);

__shimcall__ OSIRQL OsRaiseIrql(OSIRQL NewIrql, unsigned long *state);
__shimcall__ void OsRestoreIrql(OSIRQL OldIrql, unsigned long *state);

__shimcall__ void OsSoftInterruptsDisable(void);
__shimcall__ void OsSoftInterruptsEnable(void);

__shimcall__ unsigned long OsInterruptsDisable(void);
__shimcall__ void OsInterruptsRestore(unsigned long flags);


__shimcall__ int OsAtomicTestAndSetBit(int nr, volatile void * addr);

__shimcall__ void OsAtomicClearBit(int nr, volatile void * addr);

#if 0
typedef struct tagHSPINLOCK { // must be at least sizeof(spinlock_t)
	volatile unsigned int dummy;
#if defined(SPINLOCK_DEBUG) && SPINLOCK_DEBUG
#error SPINLOCK_DEBUG not supported
#endif
} OSSPINLOCK, *HOSSPINLOCK;

void OsSpinLockBhInit(HOSSPINLOCK sp);
void OsSpinLockBhAcquire(HOSSPINLOCK sp);
void OsSpinLockBhRelease(HOSSPINLOCK sp);
#endif

__shimcall__ void OsFlushTlbAll(void);

__shimcall__ int OsGetTaskStructSize(void);
__shimcall__ void *OsGetTask(void);
__shimcall__ long OsGetTaskPid(void *task);
__shimcall__ char *OsGetTaskCmd(void *task);
__shimcall__ int OsGetProcessorId(void);
__shimcall__ void OsTaskWakeUp(void *Task);
__shimcall__ void OsTaskYield(void);


typedef struct {
	struct {
		int Size;
		int BottomOffset;
		BOOL Wrap, WrapPFH;
	} Stack;

	BOOL CFG_REGPARM;
	BOOL CFG_4G_VM_LAYOUT;
	BOOL CFG_X86_SWITCH_PAGETABLES;
	BOOL CFG_PREEMPT;
	BOOL CFG_SMP;
} OS_KERNELCONFIG, *POS_KERNELCONFIG;

extern OS_KERNELCONFIG OsKernelConfig;

#define OsCallbackFunc(fn) (OsKernelConfig.CFG_REGPARM ? fn##_reg : fn##_stk)

__shimcall__ unsigned long OsGetLoopsPerTick(void);
__shimcall__ unsigned long OsGetTicksPerSec(void);

__shimcall__ unsigned long OsGetTrapDS(void);
__shimcall__ BOOLEAN OsPageFaultTrap(unsigned long error_code);

__shimcall__ int OsGetNumProcessors(void);

__shimcall__ void OsGetRandomBytes(void *buf, int nbytes);
__shimcall__ void OsSeedRandom(unsigned int seed);

typedef int OS_IRQRETURN_T;

#define OS_IRQ_NONE        (0)
#define OS_IRQ_HANDLED     (1)

typedef enum {
	OSDEVTYPE_USB = 4,
	OSDEVTYPE_PCI
} OS_DEVTYPE;

typedef struct tagOS_DEVNODE {
    HANDLE netDev;
	HANDLE miniportAdapter;
    HANDLE hwDev;
    void *hwModule;
    char  hwInstName[80];
    char  *hwDriverName;
	OS_DEVTYPE hwBusType;
    UCHAR hwAddr[6];
    char  hwLicStatus[80];
    char  netDevName[20];
} OS_DEVNODE, *POS_DEVNODE;

typedef enum {
	OSPCIRESTYPE_NULL,
	OSPCIRESTYPE_PORT,
	OSPCIRESTYPE_INTERRUPT,
	OSPCIRESTYPE_MEMORY,
	OSPCIRESTYPE_DMA,
	OSPCIRESTYPE_DEVSPEC,
	OSPCIRESTYPE_BUS
} OS_PCI_DEV_RESTYPE;

typedef struct {
	OS_PCI_DEV_RESTYPE type;
    UINT32 addr;
    UINT32 len;
} OS_PCI_DEV_RES, *POS_PCI_DEV_RES;

__shimcall__ VOID OsGetPCIDeviceResources(HANDLE DevNode, POS_PCI_DEV_RES pRes, int *nRes);

__shimcall__ VOID OsSetPciBusMaster(HANDLE DevNode);

__shimcall__ ULONG OsVirtToPhys(PVOID va);

__shimcall__ void *OsMappedToVirt(PVOID ma);

__shimcall__ PVOID OsMapPhysMem(UINT32 dwPhysMemBase, UINT32 dwMemSize);

__shimcall__ BOOL OsUnmapPhysMem(PVOID dwLinearAddr, UINT32 dwMemSize);

__shimcall__ BOOL OsHookInterrupt(HANDLE DevNode, OS_IRQRETURN_T __kernelcall__ (*isr)(int irq, void *devidp, void *unused), void* devid);

__shimcall__ void OsUnhookInterrupt(HANDLE DevNode, void *devid);

__shimcall__ void OsDisableInterrupt(HANDLE DevNode, BOOLEAN Sync);
__shimcall__ void OsEnableInterrupt(HANDLE DevNode);

#ifdef __i386__
#undef OsIoMemReadw
#define OsIoMemReadw(addr) (*(volatile unsigned short *) (addr))
#undef OsIoMemReadl
#define OsIoMemReadl(addr) (*(volatile unsigned int *) (addr))
#undef OsIoMemWritew
#define OsIoMemWritew(addr,b) (*(volatile unsigned short *) (addr) = (b))
#undef OsIoMemWritel
#define OsIoMemWritel(addr,b) (*(volatile unsigned int *) (addr) = (b))
#else
__shimcall__ unsigned short OsIoMemReadw(void *addr);

__shimcall__ unsigned int OsIoMemReadl(void *addr);

__shimcall__ void	OsIoMemWritew(void *addr, unsigned short wVal);

__shimcall__ void	OsIoMemWritel(void *addr, unsigned int dwVal);
#endif

__shimcall__ unsigned char OsIoPortReadb(unsigned int port);

__shimcall__ unsigned short OsIoPortReadw(unsigned int port);

__shimcall__ unsigned int OsIoPortReadl(unsigned int port);

__shimcall__ void	OsIoPortWriteb(unsigned int port, unsigned char bVal);

__shimcall__ void	OsIoPortWritew(unsigned int port, unsigned short wVal);

__shimcall__ void	OsIoPortWritel(unsigned int port, unsigned int dwVal);

__shimcall__ void	OsIoPortReadsb(unsigned int port, void * addr, unsigned long count);
__shimcall__ void	OsIoPortReadsw(unsigned int port, void * addr, unsigned long count);
__shimcall__ void	OsIoPortReadsl(unsigned int port, void * addr, unsigned long count);
__shimcall__ void	OsIoPortWritesb(unsigned int port, const void * addr, unsigned long count);
__shimcall__ void	OsIoPortWritesw(unsigned int port, const void * addr, unsigned long count);
__shimcall__ void	OsIoPortWritesl(unsigned int port, const void * addr, unsigned long count);

__shimcall__ int OsPciReadConfigdw(void *pPciDev, unsigned char Offset, unsigned long *pVal);

__shimcall__ int OsPciReadConfigw(void *pPciDev, unsigned char Offset, unsigned short *pVal);

__shimcall__ int OsPciReadConfigb(void *pPciDev, unsigned char Offset, unsigned char *pVal);

__shimcall__ int OsPciWriteConfigdw(void *pPciDev, unsigned char Offset, unsigned long Val);

__shimcall__ int OsPciWriteConfigw(void *pPciDev, unsigned char Offset, unsigned short Val);

__shimcall__ int OsPciWriteConfigb(void *pPciDev, unsigned char Offset, unsigned char Val);


struct file;
typedef struct file FILE;

#define SEEK_SET		0x00000000
#define SEEK_CUR		0x00000001
#define SEEK_END		0x00000002

#define EOF	(-1)

#ifndef OS_NOREDEFS
#define fopen(f,m) OsFOpen(f,m,NULL)
#define fread OsFRead
#define fwrite OsFWrite
#define fclose OsFClose
#define fseek OsFSeek
#endif // OS_NOREDEFS

__shimcall__ FILE * OsFOpen(const char *, const char *, int *error_p);
__shimcall__ size_t OsFRead(void *, size_t, size_t, FILE *);
__shimcall__ size_t OsFWrite(const void *, size_t, size_t, FILE *);
__shimcall__ int OsFClose(FILE *);
__shimcall__ int OsFSeek( FILE *stream, long offset, int origin );


typedef struct {
	enum { osConfTypeInteger, osConfTypeHexInteger, osConfTypeString, osConfTypeBinary } Type;
	union {
		long Integer;
		void *Buffer;
	} Data;
} OSCONFVALUE, *POSCONFVALUE;

typedef PVOID HOSCONF;


typedef enum {
	OSCONFORIGIN_PREDEFINED,
	OSCONFORIGIN_STATIC,
	OSCONFORIGIN_VENDOR,
	OSCONFORIGIN_CONFIG,
	OSCONFORIGIN_DRIVER
} OSCONFORIGIN;

__shimcall__ BOOLEAN OsConfigOption(const char *optionName);
__shimcall__ HOSCONF OsConfigOpen(POS_DEVNODE pDevNode, OSCONFORIGIN origin);
__shimcall__ HOSCONF OsConfigOpenWrite(POS_DEVNODE pDevNode);
__shimcall__ int OsConfigRead(HOSCONF osConfig, char *keyword, int keywordsize, POSCONFVALUE confValue);
__shimcall__ int OsConfigWrite(HOSCONF osConfig, char *keyword, POSCONFVALUE confValue, int confSize);
__shimcall__ void OsConfigClose(HOSCONF osConfig);
__shimcall__ BOOLEAN OsConfigNewInstance(POS_DEVNODE pDevNode);

__shimcall__ void OsConfigParseEthernetAddr(char *string, unsigned char *macaddr);

typedef struct tagHOSEVENT
{
	void *dummy;
} OSEVENT, *HOSEVENT;

typedef enum OSEVENT_WAIT_RESULT_ENUM
{
	OSEVENT_WAIT_OK,
	OSEVENT_WAIT_TIMEOUT,
	OSEVENT_WAIT_ERROR
} OSEVENT_WAIT_RESULT;


__shimcall__ HOSEVENT OsEventCreate(void);
__shimcall__ void OsEventDestroy(HOSEVENT hEvent);
__shimcall__ void OsEventInit(HOSEVENT hEvent);
__shimcall__ long OsEventSet(HOSEVENT hEvent);
__shimcall__ long OsEventClear(HOSEVENT hEvent);
__shimcall__ long OsEventState(HOSEVENT hEvent);
__shimcall__ void OsEventWait(HOSEVENT hEvent);
__shimcall__ OSEVENT_WAIT_RESULT OsEventWaitTime(HOSEVENT hEvent, UINT32 timeout);


typedef struct _OSTHRD OSTHRD, *POSTHRD;

__shimcall__ POSTHRD OsThreadCreate(const char *name, BOOLEAN highestprio, int *pid);
__shimcall__ void OsThreadDestroy(POSTHRD osthrd);
__shimcall__ void OsThreadExit(OSTHRD *osthrd, int code);

typedef struct tagHOSSCHED
{
	unsigned char dummy[8*sizeof(PVOID)];

} OSSCHED, *HOSSCHED;

__shimcall__ void OsThreadScheduleInit(HOSSCHED hWorkStorage, __kernelcall__ void (*func)(void *), void * data);
__shimcall__ int OsThreadSchedule(POSTHRD osthrd, HOSSCHED hWorkStorage);
__shimcall__ void OsThreadScheduleDone(void);

__shimcall__ void OsFlushWriteBuffers(void);

__shimcall__ void OsModuleUseCountInc(void);

__shimcall__ void OsModuleUseCountDec(void);

__shimcall__ int OsRunThreadSync(__kernelcall__ int (*func)(void *), void * data);

__shimcall__ int OsForkWait(char *program_path, char *argv[], char *envp[]);

__shimcall__ void OsDumpStack(void);

__shimcall__ void OsCalledFrom(void *addr);

#ifdef __cplusplus
}
#endif

#endif      /* #ifndef __OSSERVICES_H__ */
