/*
 * Copyright (c) 2003-2004 Linuxant inc.
 *
 * NOTE: The use and distribution of this software is governed by the terms in
 * the file LICENSE, which is included in the package. You must read this and
 * agree to these terms before using or distributing this software.
 *
 */

#ifndef __OSUSB_H
#define __OSUSB_H

struct tagUSBOSHAL;
typedef struct tagUSBOSHAL USBOSHAL, *PUSBOSHAL;

__shimcall__ void OsUsbInit(void);

struct usb_device;
__shimcall__ PUSBOSHAL OsUsbCreateInstance (POS_DEVNODE pDevNode, struct usb_device *udev);

__shimcall__ void OsUsbHaltInstance(PUSBOSHAL pUsbOsHal);

__shimcall__ void OsUsbDestroyInstance (PUSBOSHAL pUsbOsHal);

struct tagUSBOSPIPE;
typedef struct tagUSBOSPIPE USBOSPIPE, *PUSBOSPIPE;

__shimcall__ PUSBOSPIPE OsUsbCreatePipe(PUSBOSHAL pUsbOsHal, UCHAR bEndpointAddress, UCHAR bmAttributes, UINT16 wMaxPacketSize, UCHAR bInterval);

__shimcall__ void OsUsbDestroyPipe (PUSBOSPIPE pUsbOsPipe);


__shimcall__ INT OsUsbGetDescriptor(PUSBOSHAL pUsbOsHal, UCHAR DescType, UCHAR DescIndex, PVOID TransferBuffer, ULONG TransferBufferLength);

__shimcall__ VOID OsUsbClaimInterface(PUSBOSHAL pUsbOsHal, UCHAR InterfaceNumber, UCHAR AlternateSetting);

__shimcall__ INT OsUsbSetConfiguration(PUSBOSHAL pUsbOsHal, INT Configuration);

__shimcall__ INT OsUsbResetPort(PUSBOSHAL pUsbOsHal);
__shimcall__ INT OsUsbClearHalt(PUSBOSPIPE pUsbOsPipe);

__shimcall__ void CallbackOsUsbBulkOrIntTransferCompleted(PVOID userContext, INT UsbErrno, PVOID TransferBuffer, ULONG TransferBufferLength);
__shimcall__ INT OsUsbMakeBulkOrIntTransfer(PUSBOSPIPE pUsbOsPipe, PVOID userContext, PVOID TransferBuffer, ULONG TransferBufferLength);

__shimcall__ void CallbackOsUsbControlTransferCompleted(PVOID userContext, INT UsbErrno, UINT8 Request, UINT16 Value, UINT16 Index, PVOID TransferBuffer, ULONG TransferBufferLength);

typedef enum {
   OSUSB_TYPE_STANDARD,
   OSUSB_TYPE_CLASS,
   OSUSB_TYPE_VENDOR,
   OSUSB_TYPE_RESERVED
} OSUSB_TYPE;

typedef enum {
	OSUSB_RECIP_DEVICE,
	OSUSB_RECIP_INTERFACE,
	OSUSB_RECIP_ENDPOINT,
	OSUSB_RECIP_OTHER
} OSUSB_RECIP;

__shimcall__ INT OsUsbMakeControlTransfer(PUSBOSHAL pUsbOsHal, BOOLEAN directionIn, OSUSB_TYPE usbType, OSUSB_RECIP usbRecip, PVOID userContext, UINT8 Request, UINT16 Value, UINT16 Index, PVOID TransferBuffer, ULONG TransferBufferLength);

__shimcall__ void OsUsbAbortUrbWithContext (PUSBOSHAL pUsbOsHal, PVOID userContext);

#endif /* __OSUSB_H */
