#! /usr/bin/perl
#
# Copyright (c) 2003-2004 Linuxant inc.
#
# NOTE: The use and distribution of this software is governed by the terms in
# the file LICENSE, which is included in the package. You must read this and
# agree to these terms before using or distributing this software.
# 

use lib qw(..); # to find our own CGI.pm
use CGI;
require "../dldrparser.pm";

################################################################################

sub dumpFile {
        my ($file) = @_;
        open(FILE, $file);
        while ( <FILE> ) {
                print;
        }
        close(FILE);
}

sub helpText {
	my ($help) = @_;

	print qq{<br><center><table cellspacing=4 cellpadding=6 width=90% bgcolor=#ffffee style="border-width:1px; border-style: solid; border-color: #bbbbaa;"><tr><td valign=top><img src="/images/info.gif"></td><td width=100%>$help</td></td></table></center>};
}

################################################################################

print "Content-type: text/html\n\n";

$query  = new CGI;
$parser = new dldrparser;

%driverConfig = $parser->readConfig;
$parser->configFile($driverConfig{'vardir'} . "/" . $query->param("config"));
$hwinst = $parser->setHwInst($query->param("hwinst"));

dumpFile("includes/header.inc");

if ( stat("$driverConfig{'cnfdir'}/$hwinst") ) {
	%confFile = $parser->readConfigFile;
}

$parser->readStrings;

#
# Get Vendor and Device Section
#

$devSection = $parser->getDeviceSection;
$parser->skipToSection($devSection);
@match = $parser->parseHwInst($hwinst);
($section, $bestMatch) = $parser->findBestMatch(@match);
$parser->skipToSection($section . ".ntx86") || $parser->skipToSection($section . ".nt") || $parser->skipToSection($section);

if (open(PROCHWADDR, "/proc/driver/$driverConfig{'dldrname'}/" . $query->param('dev') . "/hwaddr")) {
        $hwaddr = <PROCHWADDR>; chop($hwaddr);
	close(PROCHWADDR);
}

if (open(PROCLIC, "/proc/driver/$driverConfig{'dldrname'}/" . $query->param('dev') . "/licstatus")) {
	$licStatus = <PROCLIC>;
	close(PROCLIC);
} else {
	$licStatus = "UNKNOWN";
}

if ( $licStatus =~ /^OK \((OEM|Demo|(.*ONLY.*))/ ) {
	$licShow = 0;
} else {
	$licShow = 1;
}


$hidden = ( defined($query->param('advanced')) ) ? 0 : 1;
$parser->setHidden($hidden);

$help = "";

if ($licShow) {
	if ( defined($confFile{'LicenseOwner'}) ) {
		$help = "Please verify the data below to ensure that it is exactly as it appears on your license from Linuxant.";
	} elsif ( defined($query->param('license_key')) ) {
		$help = qq{Your license information has been imported and is displayed below. Please click on the <i>Save</i> button to save your configuration and start using your hardware.};
	} else {
		$help = qq{Please enter the data below exactly how it appears on your Linuxant license.};
	}

	$help = $help . qq{<br><br>Instead of typing it in, you may <img src="/images/blink.gif" align=middle width=14><b> <a href='https://www.linuxant.com/store/license_view.php?registration_id=$hwaddr&config=} . $query->param('config') . qq{&product_id=lic-drvldr&hwinst=} . $query->param('hwinst') . qq{&dev=} . $query->param('dev') . qq{&svraddr=} . $ENV{'SERVER_URL'} . qq{'>fetch your license directly from Linuxant</a></b> if you are presently connected to the Internet<br>};
}

if ( $hidden eq 0 ) {
	if ($help ne "") {
		$help .= "<br><br>";
	}
	$help .= "<b>WARNING</b>: Only change the advanced settings if you know what you are doing! The default values are sufficient in most cases.";
}

if ($help ne "") {
	helpText($help);
}
print "<table border=0 width=100% cellpadding=6 cellspacing=0>";
print "<form method=post action='/cgi-bin/saveconfig.cgi'>";
print "<tr><td>Wireless interface</td><td>", $query->param('dev'), "</td></tr>";
if ($hwaddr) {
	print "<tr><td>MAC Address</td><td>", $hwaddr, "</td></tr>";
}

if ($licShow) {
	print "<tr><td>License E-Mail</td><td>";
}
print "<input name=linuxantEmail ";
if (!$licShow) {
	print "type=hidden ";
}

if ( defined($confFile{'LicenseOwner'}) ) {
	print "value='" . dldrparser::strip_quotes($confFile{'LicenseOwner'}) . "' ";
} elsif ( defined($query->param('email')) ) {
	print "value='" . $query->param('email') . "' readonly";
}
if ($licShow) {
	print " size=50></td></tr>";
	print "<tr><td>License Key</td><td>";
} else {
	print ">";
}
print "<input name=linuxantLicense ";
if (!$licShow) {
	print "type=hidden ";
}
if ( defined($confFile{'LicenseKey'}) ) {
	print "value='" . $parser->convLicense(dldrparser::strip_quotes($confFile{'LicenseKey'})) . "' ";
} elsif ( defined($query->param('license_key')) ) {
	print "value='" . $query->param('license_key') . "' readonly";
}
if ($licShow) {
	print " size=50></td></tr>";
} else {
	print ">";
}

$gui=0;
@reg = $parser->getRegSections;
foreach $regSection ( @reg ) {
	$regSection = dldrparser::trim($regSection);
	$parser->skipToSection($regSection . "ntx86") || $parser->skipToSection($regSection . "nt") || $parser->skipToSection($regSection);
	while ( $line = $parser->lookFor("HKR") ) {
		if ( $line =~ /\\params\\/i ) {
				@ret = $parser->parseParam($line);
				$out{$ret[0]} = $ret[1];
				push(@order, $ret[0]);
				$gui++;
		} elsif ( $line =~ /^(\s)*HKR(\s)*,/ ) {
				@ret = $parser->parseStaticParam($line);
				$out{$ret[0]} = $ret[1];
				push(@order, $ret[0]);
		} else {
				# NOT HANDLED
		}
	}
}

if ( defined($query->param('advanced')) ) {
	print "<input type=hidden name=linuxantSaveAdvanced value='1'>\n";
}
if ($licShow) {
	print "<input type=hidden name=linuxantSaveLicense value='1'>\n";
}
print "<input type=hidden name=linuxantServiceBinary value='" . $confFile{'ServiceBinary'} . "'>\n";
print "<input type=hidden name=linuxantDriverName value='" . $confFile{'DriverName'} . "'>\n";
print "<input type=hidden name=linuxantDriverLoaderVersion value='" . $confFile{'DriverLoaderVersion'} . "'>\n";
print "<input type=hidden name=linuxantDriverLoaderInfFile value='" . $confFile{'DriverLoaderInfFile'} . "'>\n";
print "<input type=hidden name=linuxantDriverLoaderNetDevName value='" . $confFile{'DriverLoaderNetDevName'} . "'>\n";

print "<br></table><center><br><input type=hidden name=linuxantHwInst value='" . $query->param('hwinst') . "'><input type=hidden name=linuxantDev value='" . $query->param('dev') . "'><input type=hidden name=linuxantHwaddr value='$hwaddr'>\n";
if ($licShow || ( $hidden eq 0 ) ) {
	print "<input type=submit value='Save'>";
}
if ( ! defined($query->param('advanced')) && ! defined($query->param('email')) && ($gui>0) ) {
	print qq{ <input type=button value='Advanced >>' onClick='javascript:document.location="/cgi-bin/parse.cgi?config=} . $query->param('config') . qq{&hwinst=} . $query->param('hwinst') . qq{&dev=} . $query->param('dev') . qq{&advanced"'>};
}
print qq{ <input type=button value='Cancel' onClick='javascript:document.location="/cgi-bin/config.cgi"'></center></form>};
close(INF);

dumpFile("includes/footer.inc");

exit;
